/* 
 * Copyright (c) 2001, 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 932 $ $LastChangedDate: 2002-09-11 17:06:10 +0200 (Wed, 11 Sep 2002) $
 *
 * Runtime enviroment for gont.
 *
 * Assumes compiler that allows $ in identifiers, such as GCC.
 * (It is required to have Ksi, so this ain't so important)
 */

#include <gont/runtime.h>

#include <string.h>
#include <stdarg.h>

/* Make new lambda expression. */
struct gont_lambda_expr *gont_make_lambda(void *fnc, void *closure)
{
	struct gont_lambda_expr *p;
	
	p = gont_xmalloc(sizeof(*p));
	
	p->fnc = fnc;
	p->closure = closure;
	
	return p;
}

/* Copy given float, so that it can be returned from function. */
double *gont_make_float(double v)
{
	double *ptr = gont_xmalloc_atomic(sizeof(*ptr));
	
	*ptr = v;
	
	return ptr;
}

struct gont_union *gont_make_union(gont_int field_no, void *value)
{
	struct gont_union *r;

	r = gont_xmalloc(sizeof(struct gont_union));
	r->field_no = field_no;
	r->value = value;

	return r;
}

void **gont_make_tuple(gont_int n, ...)
{
	va_list ap;
	void **p;
	gont_int i;
	
	p = gont_xmalloc(n * sizeof(void*));
	
	va_start(ap, n);
	for (i = 0; i < n; i++) 
		p[i] = va_arg(ap, void*);
	va_end(ap);
	
	return p;
}
