/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 842 $ $LastChangedDate: 2002-09-01 18:56:58 +0200 (Sun, 01 Sep 2002) $
 *
 * Cg_expr - code generation for expressions.
 */

open Ast;

struct cg_ctx {
    // cf_ == current_function_
    string cf_name;
    bool cf_is_public;
    ty cf_ret_type_instanced;
    string cf_closure_type_name;
    <cg_ctx>option parent_func;
    <cg_ctx>option parent;

    <Ksi::expr>option assign_target;
   
    // we cannot use just <var_symbol, Ksi::expr>Ptrhash::t here, and
    // Ptrhash::iter() later to make a list, since Ptrhash::iter() works
    // in random order, which breaks bootstrap comparision
    <<Ksi::expr>list>ref cf_references;
    <var_symbol, int>Ptrhash::t cf_references_hash;
}

struct fn_desc {
    string name;
    bool is_public;
    bool takes_closure_parm;
    lambda_record lambda;
}

Ksi::expr maybe_save(cg_ctx c, expr to_save, *(Ksi::expr (Ksi::expr)) in_what);
Ksi::expr compile_expr(cg_ctx c, expr e);
void push_fn_decl(cg_ctx c, fn_desc fd);
Ksi::expr local_ref(var_symbol s);
Ksi::expr vardef(cg_ctx, var_symbol s);
Ksi::expr vardef_init(cg_ctx c, var_symbol s, Ksi::expr ini);


// vim:sts=4:sw=4
