/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 840 $ $LastChangedDate: 2002-09-01 16:56:25 +0200 (Sun, 01 Sep 2002) $
 *
 * Cg_util - utilities for code generation.
 */

open Ast;

/* File to which send ksi output.  */
Stdio::FILE ksi_sink;

/* Signed integer of the same size as native pointer.  */
Ksi::ty ptroff;

/* Ksi void type.  */
Ksi::ty ksi_void;

/* Hopefully 64 bit IEEE floating point number.  */
Ksi::ty c_double;

/* Pointer to it.  This is how float type is passed around.  */
Ksi::ty c_double_ptr;

/* Pointer to structure holding string.  */
Ksi::ty gont_string;

/* Pointer to structure holding lambda expression.  */
Ksi::ty gont_lambda_expr;

/* Pointer to structure holding union.  */
Ksi::ty gont_union;

/* Pointer to tuple.  */
Ksi::ty tuple_ptr;

/* Ksi ,,polymorphic'' type.  */
Ksi::ty poly;

/* Name of closure of this function.  */
Ksi::id our_closure_id;

/* How to refer to closure of parent function.  */
Ksi::id parent_closure_id;

/* Used for values that are not going to be used.  */
Ksi::id dummy_id;

/* Type of [null_value].  */
Ksi::ty null_type;

/* Zero-pointer.  */
Ksi::expr null_value;

/* Do-nothing ksi expression.  */
Ksi::expr nop;

/* Boolean 1 constant.  */
Ksi::expr true_const;

/* Boolean 0 constant.  */
Ksi::expr false_const;

/* 0 of type [ptroff].  */
Ksi::expr zero_const;

/* 1 of type [ptroff].  */
Ksi::expr one_const;

void output_decl(Ksi::decl d);

void top_comment(string s);

Ksi::id make_id(string s);

Ksi::expr call(string name, <Ksi::expr>list args);

Ksi::expr gont_alloc(Ksi::expr sz);

Ksi::expr bin(Ksi::binop o, Ksi::expr e1, Ksi::expr e2);

Ksi::expr pair(Ksi::expr e1, Ksi::expr e2);

Ksi::expr make_vardef(Ksi::ty t, Ksi::id n, Ksi::expr ini);

<Ksi::attr>list public_attrs(bool is_public);

Ksi::expr raddr(Ksi::expr e);

Ksi::expr wfl_locate('a c, *(Ksi::expr ('a, 'b)) f, <'b>located v);

Ksi::expr symbol_union_tag(var_symbol s);

Ksi::expr tuple_nth(Ksi::expr e, int n);

Ksi::expr union_tag(Ksi::expr e);

Ksi::expr union_value(Ksi::expr e);

// vim:sts=4:sw=4
