/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 934 $ $LastChangedDate: 2002-09-11 18:22:59 +0200 (Wed, 11 Sep 2002) $
 *
 * Fileutil - Various file utility functions.
 */
 
string basename(string filename)
{
	string b = "";
	List::iter(fun void (string s) {b = s;}, String::split("/", filename));
	return b;
}

string dirname(string filename)
{
	int len = String::length(basename(filename));
	return String::sub(filename, 0, String::length(filename) - len);
}

*(string, string) split_filename(string filename)
{
	if (String::contains(filename, '.')) {
		let dot_idx = String::rindex(filename, '.') in
		let len = String::length(filename) in
		return (String::sub(filename, 0, dot_idx),
			String::sub(filename, dot_idx + 1, len - dot_idx - 1));
	} else
		return (filename, "");
}

string find_in_path(<string>list path, string filename)
{
	filename = "/" + filename;
	
	bool try_dir(string dir)
	{
		try {
			Stdio::FILE f = Stdio::fopen(dir + filename, "r");
			Stdio::fclose(f);
			filename = dir + filename;
			return true;
		} with {
		case Sys_error(_):
			return false;
		}
	}
	
	if (!List::exists(try_dir, path))
		raise Not_found;
	
	return filename;
}

void report_error(string msg)
{
	puts_err(Array::get(Sys::argv, 0) + ": " + msg + "\n");
}
